﻿define([
    "dojo/_base/declare",
    "dojo/dom",
    'dojo/dom-construct',
    "dijit/form/TextBox",
    "dijit/_WidgetsInTemplateMixin",
    "xstyle/css!./pickr.min.css",
    "./pickr.min"
],
    function (
        declare,
        dom,
        domConstruct,
        TextBox,
        _WidgetsInTemplateMixin,
        ColorPickerStyles,
        Pickr
    ) {
        return declare([_WidgetsInTemplateMixin, TextBox], {
            _defaultColor: "#FFF",

            initialize: function () {
                this.Pickr = Pickr.create({
                    el: this.textbox,
                    useAsButton: false,
                    components: {
                        // Main components
                        preview: true,
                        opacity: true,
                        hue: true,

                        // Input / output Options
                        interaction: {
                            hex: true,
                            input: true,
                            clear: true,
                            save: true
                        }
                    },
                    default: this.value || this._defaultColor,
                    swatches: ['#E08119', '#F44336', '#E91E63', '#20b2aa', '#9C27B0', '#673AB7', '#2A4B7C', '#00539C']
                });
                this.Pickr._root.button.style.width = "27px";
                this.Pickr._root.button.style.height = "27px";

                this.Pickr.on('save', cb => {
                    this.setValue(cb ? cb.toHEX().toString() : this._defaultColor);
                });
            },

            postCreate: function () {
                this.inherited(arguments);
                this.setStyles();

                //HACK this.value is not set at the very beginning 
                setTimeout(this.initialize.bind(this), 1);
            },
            setValue(value) {
                this.onFocus();
                this._setValueAttr(value);
            },
            setStyles: function () {
                if (this.domNode)
                    this.domNode.style.width = "29px";

                if (this.textbox && this.textbox.parentElement)
                    this.textbox.parentElement.style.padding = "1px 1px";
            }
        });
    });