﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",

    "epi-cms/contentediting/editors/ContentAreaEditor",
    "showcase-editor/ContentEditing/CustomCreateContentFromSelector"
],
function (
    declare,
    lang,

    ContentAreaEditor,
    CreateContentFromSelector
) {

    return declare([ContentAreaEditor], {
        executeAction: function (actionName) {
            var autoPublish = false;

            /* ------------------------------------------------- */
            /*           copied from client resources            */
            /* ------------------------------------------------- */
            if (actionName === "createnewblock") {

                this._preventOnBlur = true;

                // since we're going to create a block, we need to hide all validation tooltips because onBlur is prevented here
                this.validate(false);
                var command = new CreateContentFromSelector({
                    creatingTypeIdentifier: "episerver.core.blockdata",
                    createAsLocalAsset: true,
                    autoPublish: autoPublish,
                    allowedTypes: this.allowedTypes,
                    restrictedTypes: this.restrictedTypes
                });

                command.set("model", {
                    save: lang.hitch(this, function (block) {
                        this._preventOnBlur = false;
                        var value = lang.clone(this.get("value"), true) || [];
                        value.push(block);
                        this.set("value", value);

                        // In order to be able to add a block when creating it from a floating editor
                        // we need to set the editing parameter on the editors parent wrapper to true
                        // since it has been set to false while being suspended when switching to
                        // the secondaryView.
                        this.parent.set("editing", true);
                        this.onChange(value);

                        // Now call onBlur since it's been prevented using the _preventOnBlur flag.
                        this.onBlur();
                    }),
                    cancel: lang.hitch(this, function () {
                        this._preventOnBlur = false;
                        this.onBlur();
                    })
                });
                command.execute();
            }
            /* ------------------------------------------------- */
        }
    });
});