﻿define([
        "dojo/_base/declare",
        "dojo/_base/lang",
        "epi-cms/widget/overlay/ContentArea",
        "showcase-editor/ContentEditing/CustomCreateContentFromSelector"
    ],
    function (
        declare,
        lang,
        ContentArea,
        CreateContentFromSelector
    ) {

        return declare([ContentArea], {
            executeAction: function (actionName) {
                var autoPublish = false;

                /* ------------------------------------------------- */
                /*           copied from client resources            */
                /* ------------------------------------------------- */
                if (actionName === "createnewblock") {

                    var command = new CreateContentFromSelector({
                        creatingTypeIdentifier: "episerver.core.blockdata",
                        createAsLocalAsset: true,
                        treatAsSecondaryView: true,
                        autoPublish: autoPublish,
                        allowedTypes: this.allowedTypes,
                        restrictedTypes: this.restrictedTypes
                    });

                    command.set("model", {
                        save: lang.hitch(this, function (block) {
                            var value = lang.clone(this.model.get("value"), true) || [];
                            value.push(block);

                            this.onValueChange({
                                propertyName: this._source.propertyName,
                                value: value
                            });
                        })
                    });

                    command.execute();

                } else {
                    this.inherited(arguments);
                }
                /* ------------------------------------------------- */
            }
        });
    });