﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",

    // Shell
    "epi/shell/TypeDescriptorManager",

    // CMS
    "epi-cms/widget/command/CreateContentFromSelector",
],

    function (
        declare,
        lang,
        topic,
        when,

        // Shell
        TypeDescriptorManager,

        // CMS
        CreateContentFromSelector
    ) {

        return declare([CreateContentFromSelector], {
            _switchView: function (content) {
                // summary:
                //    Change view to Create Content with parent content
                //
                // tags:
                //    protected

                when(this.getCurrentContent(), lang.hitch(this, function (contextContent) {
                    var createAsLocalAsset = this.isPseudoContextualRoot(content) || this.createAsLocalAsset;

                    topic.publish("/epi/shell/action/changeview", "showcase-editor/ContentEditing/CustomCreateContent", null, {
                        requestedType: this.creatingTypeIdentifier,
                        parent: createAsLocalAsset ? contextContent : content,
                        editAllPropertiesOnCreate: this.editAllPropertiesOnCreate,
                        addToDestination: this.model,
                        createAsLocalAsset: createAsLocalAsset,
                        treatAsSecondaryView: this.createAsLocalAsset,
                        view: TypeDescriptorManager.getValue(this.creatingTypeIdentifier, "createView"),
                        autoPublish: this.autoPublish,
                        allowedTypes: this.allowedTypes,
                        restrictedTypes: this.restrictedTypes
                    });
                }));
            },

        });
    });