define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/when",

    // epi
    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/viewmodel/CreateContentViewModel",
],

    function (
        // dojo
        declare,
        lang,

        when,

        // epi
        ContentReference,
        CreateContentViewModel
    ) {
        return declare([CreateContentViewModel], {
            _saveSuccessHandler: function (contentLink) {
                // summary:
                //      Save success handler
                // contentLink: String
                //      The newly created content's link
                // tags:
                //      private

                var ref = new ContentReference(contentLink),
                    versionAgnosticRef = ref.createVersionUnspecificReference(),
                    changeToNewContext = lang.hitch(this, function (/*String*/targetLink) {
                        this._emitSaveEvent("saveSuccess", {
                            newContentLink: targetLink,
                            changeContext: true
                        });
                    });

                when(this.contentDataStore.refresh(contentLink), lang.hitch(this, function (newContent) {
                    if (this.addToDestination) {
                        this.addToDestination.save({
                            contentLink: versionAgnosticRef.toString(),
                            name: newContent.name,
                            typeIdentifier: this.requestedType
                        });

                        // Change to new context
                        changeToNewContext(versionAgnosticRef.toString());

                    } else {
                        // Change to new context
                        changeToNewContext(versionAgnosticRef.toString());
                    }
                }));
            },
        });

    });
