﻿define([
        "dojo/_base/declare",
        "dojo/dom",
        'dojo/dom-construct',
        "dijit/_Widget",
        "dijit/form/HorizontalSlider",
        "dijit/form/HorizontalRuleLabels",
        "dijit/form/HorizontalRule"
    ],
    function (
        declare,
        dom,
        domConstruct,
        _Widget,
        HorizontalSlider,
        HorizontalRuleLabels,
        HorizontalRule
    ) {
        return declare([_Widget, HorizontalSlider], {
            _setValueAttr: function (value, priorityChange) {
                var roundedValue = Math.round(Number(value) * 10) / 10;
                arguments[0] = roundedValue;
                this.inherited(arguments); 
                this.setValueLabel();
            },

            setValueLabel() {
                if (this.valueLabel) {
                    this.valueLabel.innerText = this.value;
                }
            },

            setCustomSliderStyles() {
                if (this.domNode) {
                    this.domNode.style.marginTop = "10px";

                    if (this.width)
                        this.domNode.style.width = this.width;
                }
            },

            startup: function () {
                this.setCustomSliderStyles();

                var currentValueLabelContainer = domConstruct.create("div",
                    {
                        class: "current--value--label--container",
                        style: "text-align: center; position: absolute; width: 20px; left: 40%;"
                    },
                    this.sliderHandle,
                    "before");

                this.valueLabel = domConstruct.create("p",
                    {
                         class: "current--value--label",
                         style: "top: -25px; position: relative;"
                    },
                    currentValueLabelContainer);

                this.setValueLabel();

                var topRuleNode = domConstruct.create("div", {}, this.topDecoration);
                var topRules = new HorizontalRule({
                    count: 11,
                    style: "height: 5px; margin: 0; top: 5px;",
                }, topRuleNode);

                var bottomRuleNode = domConstruct.create("div", {}, this.bottomDecoration, "first");
                var bottomRules = new HorizontalRule({
                    count: 3,
                    style: "height: 5px; margin: 0; top: -5px;",
                }, bottomRuleNode);

                var bottomLabelsNode = domConstruct.create("div", {}, this.bottomDecoration);
                var bottomLabels = new HorizontalRuleLabels({
                    style: "height: 1.2em; font-weight: bold;",
                    labels: ["low", "mid", "high"]
                }, bottomLabelsNode);

                this.inherited(arguments);
            },

            _mouseWheeled: function (evt) {}
        });
    });